<?php
/* 
Plugin Name: Open Encryptor
Plugin URI: http://www.opencryptor.com/
Version: v1.0
Author: Vikingzheng
Description: Base on the Open Encryptor authentication, add the one-time password security for WordPress. Distributed through <a href="http://www.opencryptor.com/" target="_blank">Open Encryptor</a>.
*/

/*
== Installation ==

1. Extract the zip file into your plugins directory into its own folder.
2. Activate the plugin in the Plugin options.
3. Customize the settings from the Options panel, if desired.

*/

/*
/--------------------------------------------------------------------\
|                                                                    |
| License: GPL                                                       |
|                                                                    |
| Login LockDown - added security measures to WordPress intended to  |
| inhibit or reduce brute force password discovery.                  |
| Copyright (C) 2007, Michael VanDeMar,                              |
| http://www.bad-neighborhood.com                                    |
| All rights reserved.                                               |
|                                                                    |
| This program is free software; you can redistribute it and/or      |
| modify it under the terms of the GNU General Public License        |
| as published by the Free Software Foundation; either version 2     |
| of the License, or (at your option) any later version.             |
|                                                                    |
| This program is distributed in the hope that it will be useful,    |
| but WITHOUT ANY WARRANTY; without even the implied warranty of     |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      |
| GNU General Public License for more details.                       |
|                                                                    |
| You should have received a copy of the GNU General Public License  |
| along with this program; if not, write to the                      |
| Free Software Foundation, Inc.                                     |
| 51 Franklin Street, Fifth Floor                                    |
| Boston, MA  02110-1301, USA                                        |   
|                                                                    |
\--------------------------------------------------------------------/
*/
function OEncryptor_getRandomCode ( ) 
{ 
	global $OE_randCode;
	$str = '1234567890'; 
	$l = strlen($str); 
	$OE_randCode = rand(1, $l); 
	for($i = 1;$i < 10;$i ++){ 
		$num = rand(0, $l); 
		$OE_randCode .= $str[$num]; 
	} 
	$tempRandom = get_option("OERandomCode");
	update_option("OERandomCode2", $tempRandom);
	update_option("OERandomCode", $OE_randCode);
}

OEncryptor_getRandomCode();

function OEncryptor_install(){
	global $wpdb;
	$table_name = $wpdb->prefix . "open_encryptor";

	if( $wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name ) {
		$sql = "CREATE TABLE " . $table_name . " (
			`open_encryptor_username` varchar(32) NOT NULL,
			`open_encryptor_password1` varchar(32) NOT NULL,
			`open_encryptor_password2` varchar(32) NOT NULL,
			`open_encryptor_password3` varchar(32) NOT NULL,
			PRIMARY KEY  (`open_encryptor_username`)
			);";

		require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
		dbDelta($sql);
	}
}

function OEncryptor_usernameExist($username) {//if the username exists in the opencryptor checklist, return the true.//good work.
	global $wpdb;
	$table_name = $wpdb->prefix . "open_encryptor";
	$result = $wpdb->get_var( "SELECT COUNT(*) FROM " . $table_name . " WHERE `open_encryptor_username` = '" . $username . "'" );
	if ( $result != 0) {
	return true;
	}
	return false;
}
function OEncryptor_authenticate($username, $password) {
	global $wpdb;
	$table_name = $wpdb->prefix . "open_encryptor";
	$OE_user = $wpdb->get_row( "SELECT * FROM " . $table_name . " WHERE `open_encryptor_username` = '" . $username . "'" );
	$m1 = $OE_user->open_encryptor_password1;
	$m2 = $OE_user->open_encryptor_password2;
	$m3 = $OE_user->open_encryptor_password3;
	$rand = get_option("OERandomCode2");
	$resulttemp=md5($rand.$m1);
	$result=substr($resulttemp, 0, 10);
	if($result == $password)
	{ 
		$m1=md5($m1.$m2.$m3);
		$m2=md5($m2.$resulttemp);
		$m3=md5($resulttemp.$m3);
		$results = $wpdb->query("UPDATE " . $table_name . " SET open_encryptor_password1 = '$m1', open_encryptor_password2 = '$m2', open_encryptor_password3 = '$m3' WHERE open_encryptor_username = '$username' ");
	return true;
	} 
	return false;
	/*$m1 = $OE_user->open_encryptor_password1;//when password = 1, user: admin can logon successfully.
	if ( $m1 == $password ) {
		return true;
	}
	return false;*/
}

function OEncryptor_ap() {
	if ( function_exists('add_options_page') ) {
	//ӹ˵
		add_options_page('Login LockDown', 'Open Encryptor', 9, basename(__FILE__), 'print_OEncryptor_adminPage');
	}
}

function OEncryptor_userList() {//user's list
	global $wpdb;
	$table_name = $wpdb->prefix . "open_encryptor";

	$userlist = $wpdb->get_results("SELECT open_encryptor_username FROM $table_name");

	return $userlist;
}

function wp_userList() {//user's list
	global $wpdb;
	$table_name = $wpdb->prefix . "users";

	$userlist = $wpdb->get_results("SELECT user_login FROM $table_name");

	return $userlist;
}

function OEncryptor_link(){
	global $OE_randCode;
	echo "<p>The rand number is <b>" . $OE_randCode . "</b>.</p>";
	echo "<p><img src = 'http://www.opencryptor.com/res/logos.png' alt='opencryptor'>Account protected by <a href='http://www.opencryptor.com/' target='_blank'>Opencryptor</a>.<br /><br /><br /><br /></p>";
}

if ( function_exists('OEncryptor_install')) {//
	//Actions
	add_action('admin_menu', 'OEncryptor_ap');
	if(!defined('PLUGINDIR')){
		define('PLUGINDIR', 'wp-content/plugins');
	}
	$activatestr = str_replace(ABSPATH.PLUGINDIR."/", "activate_", __FILE__);
	register_activation_hook($activatestr, 'OEncryptor_install');
	add_action('login_form', 'OEncryptor_link');
	//Filters
	//Functions
	if ( !function_exists('wp_authenticate') ) :
	function wp_authenticate($username, $password) {
		global $wpdb;
		$username = sanitize_user($username);
		if ( '' == $username )
			return new WP_Error('empty_username', __('<strong>ERROR</strong>: The username field is empty.'));

		if ( '' == $password ) {
			return new WP_Error('empty_password', __('<strong>ERROR</strong>: The password field is empty.'));
		}
		
		$user = get_userdatabylogin($username);

		if ( !$user || ($user->user_login != $username) ) {
			do_action( 'wp_login_failed', $username );
			return new WP_Error('invalid_username', __('<strong>ERROR</strong>: Invalid username.'));
		}

		if ( OEncryptor_usernameExist( $username ) ) {
			if ( OEncryptor_authenticate($username, $password) ) {
				update_option("OERandomCode2", "");
				return new WP_User($user->ID);
			}
			do_action( 'wp_login_failed', $username );
			return new WP_Error('incorrect_password', __('<strong>ERROR</strong>: Incorrect password.'));
		}
		
		$user = apply_filters('wp_authenticate_user', $user, $password);
		
		if ( is_wp_error($user) ) {
			do_action( 'wp_login_failed', $username );
			return $user;
		}
	
		if ( !wp_check_password($password, $user->user_pass, $user->ID) ) {
			do_action( 'wp_login_failed', $username );
			return new WP_Error('incorrect_password', __('<strong>ERROR</strong>: Incorrect password.'));
		}
	
		return new WP_User($user->ID);

	}
	endif;
}

function print_OEncryptor_adminPage() {
	global $wpdb;
	$table_name = $wpdb->prefix . "open_encryptor";
	$oeuserlist = OEncryptor_userList();
	$wpuserlist = wp_userList();
	$OEOptions = get_option("OEOptions");

	if($OEOptions == 1){

		$OEOptions = 0;
		update_option("OEOptions", $OEOptions);

?>
<div class="updated"><p><strong><?php _e("New User Added.", "opencryptor");?></strong></p></div>
<?php
	}
	if($OEOptions == 2){
		$OEOptions = 0;
		update_option("OEOptions", $OEOptions);
?>
<div class="updated"><p><strong><?php _e("User Initialized.", "opencryptor");?></strong></p></div>
<?php
	}
	if($OEOptions == 3){
		$OEOptions = 0;
		update_option("OEOptions", $OEOptions);
?>
<div class="updated"><p><strong><?php _e("User Deleted.", "opencryptor");?></strong></p></div>
<?php
	}

	if (isset($_POST['add_new_oeuser'])) {
		if (isset($_POST['new_oeusers']) && isset($_POST['initial_password'])) {
			$insert = "INSERT INTO " . $table_name . " (open_encryptor_username, open_encryptor_password1, open_encryptor_password2, open_encryptor_password3) VALUES ('"
			. $_POST['new_oeusers']. "', '" . $_POST['initial_password']. "', '" . $_POST['initial_password']. "', '" . $_POST['initial_password']. "')";
			$results = $wpdb->query( $insert );
			$OEOptions = 1;
			update_option("OEOptions", $OEOptions);
		}
			echo "<script language=javascript>location='options-general.php?page=opencryptor.php'</script>";
	}
	if (isset($_POST['update_new_password'])) {
		if (isset($_POST['users']) && isset($_POST['new_password'])) {
			$update = "UPDATE " . $table_name . " SET open_encryptor_password1 = '".$_POST['new_password']."', open_encryptor_password2 = '".$_POST['new_password']."', open_encryptor_password3 = '".$_POST['new_password']."' WHERE open_encryptor_username = '" .$_POST['users']. "'";
			$results = $wpdb->query($update);
			$OEOptions = 2;
			update_option("OEOptions", $OEOptions);
		}
			echo "<script language=javascript>location='options-general.php?page=opencryptor.php'</script>";
	}
	if (isset($_POST['delete_oeuser'])) {
		if (isset($_POST['unwanted_user'])) {
			$delete = "DELETE FROM " . $table_name . " WHERE open_encryptor_username = '" .$_POST['unwanted_user']. "'";
			$results = $wpdb->query($delete);
			$OEOptions = 3;
			update_option("OEOptions", $OEOptions);
		}
			echo "<script language=javascript>location='options-general.php?page=opencryptor.php'</script>";
	}
?>

<div class=wrap>
<form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
<h2><?php _e('Opencryptor Options', 'opencryptor') ?></h2>
<h3><?php _e('Unprotected User List', 'opencryptor') ?></h3>
<select name="new_oeusers" size="1">
<?php  foreach ($wpuserlist as $singlewpuserList) {
			$flag = 0;
			foreach ($oeuserlist as $singleoeuserList) {
				if ($singleoeuserList->open_encryptor_username == $singlewpuserList->user_login)
				$flag = 1;
			}
			if ($flag == 0) {
				echo "<option value=" . $singlewpuserList->user_login . ">" . $singlewpuserList->user_login . "</option>\n";
			}
		}?>
</select><br/>
<p>Initial Code</p>
<input type="text" name="initial_password" value="" size="6"/><p>Select an user and set its Initial Code. Press "OK".</p>
<div class="submit">
<input type="submit" name="add_new_oeuser" value="<?php _e('OK', 'opencryptor') ?>" /></div>
</form>
<form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
<h3><?php _e('Protected User List', 'opencryptor') ?></h3>
<select name="users" size="1">
<?php  foreach ($oeuserlist as $singleoeuserList) {
			echo "<option value=" . $singleoeuserList->open_encryptor_username . ">" . $singleoeuserList->open_encryptor_username . "</option>\n";
		}?>
</select>
<p>Initial Code</p>
<input type="text" name="new_password" value="" size="6"/><p>Select an user and reset its Initial Code. Press "OK".</p>
<div class="submit">
<input type="submit" name="update_new_password" value="<?php _e('OK', 'opencryptor') ?>" /></div>
</form>
<form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
<h3><?php _e('Delete Protection', 'opencryptor') ?></h3>
<select name="unwanted_user" size="1">
<?php  foreach ($oeuserlist as $singleoeuserList) {
			echo "<option value=" . $singleoeuserList->open_encryptor_username . ">" . $singleoeuserList->open_encryptor_username . "</option>\n";
		}?>
</select><p>Select an user. Press "OK".</p>
<div class="submit">
<input type="submit" name="delete_oeuser" value="<?php _e('OK', 'opencryptor') ?>" /></div>
<p>If you like this plugin, wish you can donate it for its development.</p>
</form>
<form action="https://www.paypal.com/cgi-bin/webscr" method="post">
	<input type="hidden" name="cmd" value="_s-xclick">
	<input type="hidden" name="hosted_button_id" value="6929467">
	<input type="image" src="https://www.paypal.com/en_US/i/btn/btn_donateCC_LG.gif" border="0" name="submit" alt="PayPal - The safer, easier way to pay online!">
	<img alt="" border="0" src="https://www.paypal.com/en_US/i/scr/pixel.gif" width="1" height="1">
</form><br/>
</div>
<?php
}


?>